# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import typing_extensions
import typing
from ..core.serialization import FieldMetadata
import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class TavusConversationProperties(UniversalBaseModel):
    max_call_duration: typing_extensions.Annotated[typing.Optional[float], FieldMetadata(alias="maxCallDuration")] = (
        pydantic.Field(default=None)
    )
    """
    The maximum duration of the call in seconds. The default `maxCallDuration` is 3600 seconds (1 hour).
    Once the time limit specified by this parameter has been reached, the conversation will automatically shut down.
    """

    participant_left_timeout: typing_extensions.Annotated[
        typing.Optional[float], FieldMetadata(alias="participantLeftTimeout")
    ] = pydantic.Field(default=None)
    """
    The duration in seconds after which the call will be automatically shut down once the last participant leaves.
    """

    participant_absent_timeout: typing_extensions.Annotated[
        typing.Optional[float], FieldMetadata(alias="participantAbsentTimeout")
    ] = pydantic.Field(default=None)
    """
    Starting from conversation creation, the duration in seconds after which the call will be automatically shut down if no participant joins the call.
    Default is 300 seconds (5 minutes).
    """

    enable_recording: typing_extensions.Annotated[typing.Optional[bool], FieldMetadata(alias="enableRecording")] = (
        pydantic.Field(default=None)
    )
    """
    If true, the user will be able to record the conversation.
    """

    enable_transcription: typing_extensions.Annotated[
        typing.Optional[bool], FieldMetadata(alias="enableTranscription")
    ] = pydantic.Field(default=None)
    """
    If true, the user will be able to transcribe the conversation.
    You can find more instructions on displaying transcriptions if you are using your custom DailyJS components here.
    You need to have an event listener on Daily that listens for `app-messages`.
    """

    apply_greenscreen: typing_extensions.Annotated[typing.Optional[bool], FieldMetadata(alias="applyGreenscreen")] = (
        pydantic.Field(default=None)
    )
    """
    If true, the background will be replaced with a greenscreen (RGB values: `[0, 255, 155]`).
    You can use WebGL on the frontend to make the greenscreen transparent or change its color.
    """

    language: typing.Optional[str] = pydantic.Field(default=None)
    """
    The language of the conversation. Please provide the **full language name**, not the two-letter code.
    If you are using your own TTS voice, please ensure it supports the language you provide.
    If you are using a stock replica or default persona, please note that only ElevenLabs and Cartesia supported languages are available.
    You can find a full list of supported languages for Cartesia here, for ElevenLabs here, and for PlayHT here.
    """

    recording_s_3_bucket_name: typing_extensions.Annotated[
        typing.Optional[str], FieldMetadata(alias="recordingS3BucketName")
    ] = pydantic.Field(default=None)
    """
    The name of the S3 bucket where the recording will be stored.
    """

    recording_s_3_bucket_region: typing_extensions.Annotated[
        typing.Optional[str], FieldMetadata(alias="recordingS3BucketRegion")
    ] = pydantic.Field(default=None)
    """
    The region of the S3 bucket where the recording will be stored.
    """

    aws_assume_role_arn: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="awsAssumeRoleArn")] = (
        pydantic.Field(default=None)
    )
    """
    The ARN of the role that will be assumed to access the S3 bucket.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
